//+------------------------------------------------------------------+
//|                                             PipKiller_Expert.mq5 |
//|                       Copyright 2020, BallerQuotesForexSoftwares |
//|                                        https://ballerquotes.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, kibetKirui"
#property link      "https://kibetfestus666@gmail.com"
#property version   "2.00"

#include <Trade\Trade.mqh>
#include <Trade\AccountInfo.mqh>
//#include <MT4Orders.mqh> 


CTrade Trade, trade;
CPositionInfo Position;

enum TradeType{BUY,SELL,BOTH};

//+-------------------------Input Variables------------------------+
input int      MagicNumber          =  29072020;
input TradeType TradeFilter         = BOTH;
input bool      ReverseMode         = false;
input int      SignalCandle         =  4;
input double   Lots                 =  0.01;
input bool     SetTP                =  false;
input bool     SetSL                =  false;
input int      TakeProfit           =  1500; //TakeProfit (Point)
input int      StopLoss             =  400;  //StopLoss   (Point)
input int      Max_TradesPerSignal  =  10; 
input bool     Exit_On_Opp_Signal   =  true;
input bool     Use_Trailing         =  true;
//input int      StartTrailDistance   =  700; // Start Trail Distance (Point)
//input int      TrailingDistance     =  200; // TrailingDistance (Point)
//input int      TrailInterval        =  50;  // TrailInterval (Point)
input bool     Use_ExitAll          = false;
input double   ProfitTarget         = 20;
input bool     Use_PartialClose     = false;
//input double   closelots            = 0.001;
input double partialCloseRatio = 0.5 ;
input double trailStartFraction = 0.5 ;
input double trailStepFraction = 0.25 ;
input int  retry_Time_Minutes = 10 ;
input string   TComment             =  "Stamford Capital";


//+-------------------------Global Variables------------------------+
static int Traded_This_Bar;
bool close_all, set_sltp;
int IND_handle1, IND_handle2, IND_handle3, IND_handle4;
int slippage = 3;


//+------------------------------------------------------------------+
int OnInit()
  {
      Trade.SetTypeFillingBySymbol(_Symbol);
      Trade.SetExpertMagicNumber(MagicNumber);
      Trade.SetDeviationInPoints(slippage);
      
      
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
double Ask ,Bid ;


static datetime lastOpen = 0 ;

void OnTick()
  {      
     LatestObject();
     
     //---   
       Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
       Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK); 
      bool   buy = false, sell = false;   
      
     //---
     if(ReverseMode == false)
     {
        if(Signal() == "Buy") 
           {
              Comment("Buy: ", LatestObject());
              buy = true;
           } 
        if(Signal() == "Sell") 
           {
              Comment("Sell: ", LatestObject());
              sell = true;
           }
        //---
         if(Exit_On_Opp_Signal == true) 
           {
            if(buy == true) CloseAllSell(); 
            else if(sell == true) CloseAllBuy();
           }
           
           
           
         //---
         if(Traded_This_Bar!=Bars(_Symbol,PERIOD_CURRENT)) 
           {
            double volume = LotsOptimized(); 
               
            if((TradeFilter == BUY || TradeFilter == BOTH) && buy == true && CurrentBuyOrders() < Max_TradesPerSignal )
              {
               lastOpen = TimeCurrent() ;
               bool res = Trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,volume,Ask,0,0,TComment);
               if(res>0) 
                 {
                  Traded_This_Bar=Bars(_Symbol,PERIOD_CURRENT);
                  set_sltp = true;
                 }
               else 
               
               {
                Print(Trade.CheckResultRetcodeDescription());
                 if (TimeCurrent()-lastOpen>=retry_Time_Minutes*60)
                   bool rest = Trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,volume,Ask,0,0,TComment);
                }
              }
            else 
            if((TradeFilter == SELL || TradeFilter == BOTH) && sell == true && CurrentSellOrders() < Max_TradesPerSignal)
              {
               lastOpen = TimeCurrent() ;
               bool res = Trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,volume,Bid,0,0,TComment);
               if(res>0)
                 {
                  Traded_This_Bar=Bars(_Symbol,PERIOD_CURRENT);
                  set_sltp = true;
                 }
               else
               {
                 Print(Trade.CheckResultRetcodeDescription());
                  if (TimeCurrent()-lastOpen>=retry_Time_Minutes*60)
                    bool rest = Trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,volume,Bid,0,0,TComment);
                 }
              }
           }
      } 
      
      if(ReverseMode == true)
      {
        if(Signal() == "Buy") 
           {
              Comment("Sell: ", LatestObject());
              sell = true;
           } 
        if(Signal() == "Sell") 
           {
              Comment("Buy: ", LatestObject());
              buy = true;
           }
        //---
         if(Exit_On_Opp_Signal == true) 
           {
            if(buy == true) CloseAllSell(); 
            else if(sell == true) CloseAllBuy();
           }
           
         //---
         if(Traded_This_Bar!=Bars(_Symbol,PERIOD_CURRENT)) 
           {
            double volume = LotsOptimized(); 
               
            if((TradeFilter == BUY || TradeFilter == BOTH) && buy == true && CurrentBuyOrders() < Max_TradesPerSignal )
              {
               lastOpen = TimeCurrent() ;
               bool res = Trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,volume,Ask,0,0,TComment);
               if(res>0) 
                 {
                  Traded_This_Bar=Bars(_Symbol,PERIOD_CURRENT);
                  set_sltp = true;
                 }
               else 
               {
                Print(Trade.CheckResultRetcodeDescription());
                 if (TimeCurrent()-lastOpen>=retry_Time_Minutes*60)
                 bool rest = Trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,volume,Ask,0,0,TComment);
                }
              }
            else 
            if((TradeFilter == SELL || TradeFilter == BOTH) && sell == true && CurrentSellOrders() < Max_TradesPerSignal)
              {
               lastOpen = TimeCurrent() ;
               bool res = Trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,volume,Bid,0,0,TComment);
               if(res>0)
                 {
                  Traded_This_Bar=Bars(_Symbol,PERIOD_CURRENT);
                  set_sltp = true;
                 }
               else
               {
                 Print(Trade.CheckResultRetcodeDescription());
                  if (TimeCurrent()-lastOpen>=retry_Time_Minutes*60)
                  bool rest = Trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,volume,Bid,0,0,TComment);
                 }
              }
           }
      }   
      PlaceSLTP();
      CloseWithExitAll();
      
      if(Use_Trailing)
         {
            //SetTrailing(); 
            trail();
         }
         
      if(Use_PartialClose)
      {
         //ClosePartially();
         partialClose();
      }
      
      return;              
  }
//+------------------------------------------------------------------+
string Signal()
  {
      string Signal = "";
      static string LastObject = "";
             string Comp       = LatestObject();
          
      if(LastObject != Comp)
         {
            LastObject = Comp;
         }
      if(LastObject == "Bearish Engulfing" || LastObject == "Bear Cross" || LastObject == "Dark Cloud" || LastObject == "Shooting Star" || LastObject == "Hammer" || LastObject == "Bear Harami")
         {
            Signal = "Sell";
         }
      if(LastObject == "Bullish Engulfing" || LastObject == "Bull Cross" || LastObject == "Bull Harami" || LastObject == "Bullish Piercing")
         {
            Signal = "Buy";
         }
      return Signal;
  }
//+------------------------------------------------------------------+
string LatestObject()
  {
   string   Name  = "";
   string   Description = "";
   long Time        = -1;
   datetime CheckTime   = iTime(NULL,PERIOD_CURRENT,SignalCandle);
   
   int    Total = ObjectsTotal(0);

   for(int i = 0; i < Total; i++)
     {
         Name         = ObjectName(0,i);
         Description  = ObjectGetString(0,Name,OBJPROP_TEXT);
         Time         = ObjectGetInteger(0,Name,OBJPROP_TIME);  
                     
         if(Description == "")continue;
         if(Description == TComment)continue;
         if(Description != "")
         if(Time < CheckTime)continue;
         if(Time >= CheckTime)
            {
               Description = ObjectGetString(0,Name,OBJPROP_TEXT);
               break;
            }
     }
   return Description;
  }
//+------------------------------------------------------------------+
double LinePrice(color clr)
{
   string   name, desc;
   long      type;
   
   long Clr;
   
   double price = 0;
   
   long time        = -1;
   datetime checkTime   = iTime(NULL,PERIOD_CURRENT,SignalCandle);
   
   int    total = ObjectsTotal(0);
   
   for(int i = 0; i < total; i++)
     {
         name         = ObjectName(0,i);
         desc         = ObjectGetString(0,name,OBJPROP_TEXT);
         time         = ObjectGetInteger(0,name,OBJPROP_TIME);
         type         = ObjectGetInteger(0,name,OBJPROP_TYPE);
         Clr          = ObjectGetInteger(0,name,OBJPROP_COLOR);
           
         if(desc != "")continue;
         //if(time < checkTime)continue;
         if(Clr != clr)continue;
         if(type == OBJ_TREND)
         {
            price = ObjectGetDouble(0,name,OBJPROP_PRICE);
            break;
         }
     }
     
   return price; 
}
//+------------------------------------------------------------------+
//| Order Accounting - Checking for Open Buy Orders                  |
//+------------------------------------------------------------------+
int CurrentBuyOrders() 
  { 
   int buys=0; 
   for(int i = 0;i<PositionsTotal();i++)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY) 
           {
            buys++;
           }
        }
     }
   return(buys);
  }
//+------------------------------------------------------------------+
//| Order Accounting - Checking for Open Sell Orders                 |
//+------------------------------------------------------------------+
int CurrentSellOrders() 
  { 
   int sells=0; 
   for(int i = 0;i<PositionsTotal();i++)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) 
           {
            sells++;
           }
        }
     }
   return(sells);
  }
//+------------------------------------------------------------------+
//|Function Closes All Trades                                        |
//+------------------------------------------------------------------+
bool CloseAllTrades()
  { 
   bool result = true, close;  
   for(int i = PositionsTotal()-1;i>=0;i--)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         close = Trade.PositionClose(ticket,50);
         if(!close) 
           {
            result = false; 
            Print(Trade.CheckResultRetcodeDescription());
           }
        }
     }
   return(result);
  }
//+------------------------------------------------------------------+
//| Function Closes All Open Buy Orders                              |
//+------------------------------------------------------------------+
bool CloseAllBuy()
  { 
   bool result = true, close;  
   for(int i = PositionsTotal()-1;i>=0;i--)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY) 
           {
            close = Trade.PositionClose(ticket,50);
            if(!close) 
              {
               result = false; 
               Print(Trade.CheckResultRetcodeDescription());
              }
           }
        }
     }
   return(result);
  }
//+------------------------------------------------------------------+
//|Function CLoses All Open Sell Orders                              |
//+------------------------------------------------------------------+
bool CloseAllSell()
  { 
   bool result = true, close;  
   for(int i = PositionsTotal()-1;i>=0;i--)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) 
           {
            close = Trade.PositionClose(ticket,50);
            if(!close) 
              {
               result = false; 
               Print(Trade.CheckResultRetcodeDescription());
              }
           }
        }
    }
   return(result);
  }
//+------------------------------------------------------------------+
//| Place Stop Loss and Take Profit                                  |
//+------------------------------------------------------------------+
bool PlaceSLTP() 
  { 
   bool result = true;  
   for(int i = PositionsTotal()-1;i>=0;i--)  
     {
      ulong ticket = PositionGetTicket(i);
      if(ticket>0 && PositionGetString(POSITION_SYMBOL) ==_Symbol && PositionGetInteger(POSITION_MAGIC)==MagicNumber && PositionGetString(POSITION_COMMENT)==TComment ) 
        {
         if(PositionGetDouble(POSITION_SL)==0 && PositionGetDouble(POSITION_TP)==0 && (SetSL || SetTP) ) 
           {
            double sl =0, tp =0;
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY) 
              {
               if(SetSL) sl = LinePrice(clrLime);
               if(SetTP) tp = LinePrice(clrRed);
              }
            else 
              {
               if(SetSL) sl = LinePrice(clrRed);;
               if(SetTP) tp = LinePrice(clrLime);;
              }
            bool res = Trade.PositionModify(ticket,sl,tp);
            if(!res) 
              {
               result = false;
               Print(Trade.CheckResultRetcodeDescription());
              }
          }
        }
    }
   return(result);
  }
//+------------------------------------------------------------------+
//Function for setting trailing stop based on Lotsize                |
//+------------------------------------------------------------------+
/*
void SetTrailing() 
  {
   for(int i=0;i<PositionsTotal();i++) 
     {
      if(!Position.SelectByIndex(i)) continue; 
      if(Position.Symbol()!=_Symbol) continue; 
      
      ulong ticket = Position.Ticket();
      string symbol = Position.Symbol();
      
      double point = SymbolInfoDouble(symbol,SYMBOL_POINT);
      int stoplevel = (int) SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL); 
      int digit = (int) SymbolInfoInteger(symbol,SYMBOL_DIGITS); 
      
      double TrailStart = MathAbs((LinePrice(clrLime) - LinePrice(clrRed))/Point());
      TrailStart = NormalizeDouble(TrailStart/2,1);
   
      if(Position.PositionType() == POSITION_TYPE_BUY) 
        {
         double new_sl = NormalizeDouble(Position.PriceCurrent() - TrailingDistance*point,digit);
         new_sl = MathMin(new_sl,Position.PriceCurrent()-stoplevel*point);
         if(Position.PriceOpen() > Position.PriceOpen() + (TrailStart * Point()) && Position.PriceCurrent() - Position.PriceOpen() >= StartTrailDistance*point && new_sl- Position.StopLoss()>= TrailInterval*point ) 
           {
            bool mod = Trade.PositionModify(ticket,new_sl,Position.TakeProfit());
           }
        }
      
      if(Position.PositionType() == POSITION_TYPE_SELL) 
        {
         double new_sl = NormalizeDouble(Position.PriceCurrent() + TrailingDistance*point,digit);
         new_sl = MathMax(new_sl,Position.PriceCurrent()+stoplevel*point);
         if(Position.PriceOpen() > Position.PriceOpen() - (TrailStart * Point()) && Position.PriceOpen() - Position.PriceCurrent() >= StartTrailDistance*point && (Position.StopLoss()==0 || Position.StopLoss() - new_sl >= TrailInterval*point ) ) 
           {
            bool mod = Trade.PositionModify(ticket,new_sl,Position.TakeProfit());
           }
        }
     }
  }
  */
  
  
  //-----------------------------------------------------------------------------------+
void trail ()
 {
   
    if (PositionsTotal()>0)
  for (int i = PositionsTotal()-1 ; i>=0 ; i--)
  {
     ulong ticket = PositionGetTicket(i) ;
       PositionSelectByTicket(ticket) ;
       long p_magic = PositionGetInteger(POSITION_MAGIC) ; 
       long type = PositionGetInteger(POSITION_TYPE) ;
       double p_open = PositionGetDouble(POSITION_PRICE_OPEN) ;
        double sl = PositionGetDouble(POSITION_SL) ;
         double tp = PositionGetDouble(POSITION_TP) ;
         
         if (type==POSITION_TYPE_BUY && Bid-p_open>=trailStartFraction*(tp-p_open) && Bid-trailStepFraction*(tp-p_open)>sl && p_magic==MagicNumber)
             trade.PositionModify(ticket,NormalizeDouble(Bid-trailStepFraction*(tp-p_open),_Digits),tp) ;
         if (type==POSITION_TYPE_SELL && p_open-Ask>=trailStartFraction*(p_open-tp) && Ask+trailStepFraction*(p_open-tp)<sl && p_magic ==MagicNumber)
             trade.PositionModify(ticket,NormalizeDouble(Ask+trailStepFraction*(p_open-tp),_Digits),tp) ;
  } 
 
 
 }
 
//+------------------------------------------------------------------+
double LotsOptimized()
    {
       double LotSize =  Lots;
       
       double MinimumLots = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
       double MaximumLots = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
       
       if(LotSize < MinimumLots)
         {
            LotSize = MinimumLots;
         }
       if(LotSize > MaximumLots)
         {
            LotSize = MaximumLots;
         }
         
      return LotSize;
    }
//+------------------------------------------------------------------+
double Profit()
   {
      double profit = 0;
      
      for(int i = 0; i < PositionsTotal(); i++)
         {
            if(PositionGetSymbol(i) != Symbol())continue;
            if(PositionGetString(POSITION_COMMENT) != TComment)continue;
            
            double PositionProfit = PositionGetDouble(POSITION_PROFIT);
            double PositionSwap = PositionGetDouble(POSITION_SWAP);
            
            profit = profit + PositionProfit + PositionSwap;
         }
         
      return profit;
   }
//+------------------------------------------------------------------+
void CloseWithExitAll()
{
   if(Use_ExitAll == true)
   {
      if(Profit() >= ProfitTarget)
      {
         CloseAllTrades();
      }
   }
}
//+------------------------------------------------------------------+
void CloseAllPositions(ulong EA_Magic)
   {
      MqlTradeRequest request;
      MqlTradeResult  result;
      
      int Total = PositionsTotal();
      
      for(int i = Total - 1; i >= 0; i--)
         {
            string Position_Symbol  = PositionGetString(POSITION_SYMBOL);
            ulong  Position_Ticket  = PositionGetTicket(i);
            ulong  Position_magic   = PositionGetInteger(POSITION_MAGIC);
            double Position_volume  = PositionGetDouble(POSITION_VOLUME);
            ENUM_POSITION_TYPE type = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
            
            if(Position_Ticket > 0)
               {
                  if(Position_magic == EA_Magic)
                     {
                        ZeroMemory(request);
                        ZeroMemory(result);
                        
                        request.action       = TRADE_ACTION_DEAL;
                        request.type_filling = ORDER_FILLING_IOC;
                        request.position     = Position_Ticket;
                        request.symbol       = Position_Symbol;
                        request.volume       = Position_volume;
                        request.deviation    = 5;
                        request.magic        = Position_magic;
                        
                        if(type == POSITION_TYPE_BUY)
                           {
                              request.price = SymbolInfoDouble(Position_Symbol,SYMBOL_BID);
                              request.type  = ORDER_TYPE_SELL;
                           }
                           
                        else if (type == POSITION_TYPE_SELL)
                           {
                              request.price = SymbolInfoDouble(Position_Symbol,SYMBOL_ASK);
                              request.type  = ORDER_TYPE_BUY;
                           }
                           
                        if(!OrderSend(request,result))   
                           {
                              int Err = GetLastError();
                              Print("Close Error - ",Err);
                           }
                      }
               }
         }
   }
//------------------------------------------------------------------------------
/*
double CloseLots()
{
   double lot = closelots;
      
   double MinimumLots = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   double MaximumLots = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
       
   if(lot < MinimumLots)
     {
         lot = MinimumLots;
     }
   if(lot > MaximumLots)
     {
         lot = MaximumLots;
     }
     
   return lot;
}
//-------------------------------------------------------------------------+

void ClosePartially()
{
   double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
   double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK); 
   
   double LottoClose = CloseLots();
   double distance = MathAbs((LinePrice(clrRed) - LinePrice(clrLime))/Point());
   for(int j =0; j < OrdersTotal(); j++)
   {
      if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol())
      {
         if(OrderType() == 0 && Ask >= OrderOpenPrice() + (distance * Point()))
         { 
             if(!trade.PositionClosePartial(OrderTicket(),LottoClose))
             {
               Print("Error closing trade partially: ",GetLastError());
             }
         }
        if(OrderType() == 1 && Bid <= OrderOpenPrice() - (distance * Point()))
         { 
             if(!trade.PositionClosePartial(OrderTicket(),LottoClose))
             {
               Print("Error closing trade partially: ",GetLastError());
             }
         }
      }
    }
}
*/

//---------------------------------------------------------------------+
 void partialClose()
  {
  
  if (PositionsTotal()>0)
  for (int i = PositionsTotal()-1 ; i>=0 ; i--)
  {
     ulong ticket = PositionGetTicket(i) ;
       PositionSelectByTicket(ticket) ;
       long p_magic = PositionGetInteger(POSITION_MAGIC) ; 
       long type = PositionGetInteger(POSITION_TYPE) ;
       double p_open = PositionGetDouble(POSITION_PRICE_OPEN) ;
        double sl = PositionGetDouble(POSITION_SL) ;
         double tp = PositionGetDouble(POSITION_TP) ;
         
         if (type==POSITION_TYPE_BUY && Bid-p_open>=partialCloseRatio*(tp-p_open)&&p_magic==MagicNumber)
             trade.PositionClosePartial(ticket,partialCloseRatio*Lots,-1) ;
         if (type==POSITION_TYPE_SELL && p_open-Ask>=partialCloseRatio*(p_open-tp)&&p_magic==MagicNumber)
             trade.PositionClosePartial(ticket,partialCloseRatio*Lots,-1) ;
             
   } 
   
 }
 